Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageStencilData Class Reference

`#include <vtkImageStencilData.h>`

Inheritance diagram for vtkImageStencilData:

[legend]
Collaboration diagram for vtkImageStencilData:

[legend]
List of all members.

## Detailed Description

efficient description of an image stencil

Date:
  2002/11/12 19:21:02

Revision:
  1.8

vtkImageStencilData describes an image stencil in a manner which is efficient both in terms of speed and storage space. The stencil extents are stored for each x-row across the image (multiple extents per row if necessary) and can be retrieved via the GetNextExtent() method.

See also:
  vtkImageStencilSource vtkImageStencil

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (90%)

CVS logs (CVSweb):
  - .`h` (`/Imaging/vtkImageStencilData.h)`
  - .`cxx` (`/Imaging/vtkImageStencilData.cxx)`

Definition at line 46 of file vtkImageStencilData.h.

## Public Types
typedef vtkDataObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual vtkDataObject * | MakeObject ()
void | Initialize ()
void | DeepCopy (vtkDataObject *o)
void | ShallowCopy (vtkDataObject *f)
void | InternalImageStencilDataCopy (vtkImageStencilData *s)
int | GetDataObjectType ()
int | GetExtentType ()
void | InsertNextExtent (int r1, int r2, int yIdx, int zIdx)
void | AllocateExtents ()
void | UpdateData ()
void | PropagateUpdateExtent ()
void | TriggerAsynchronousUpdate ()
int | GetNextExtent (int &r1, int &r2, int xMin, int xMax, int yIdx, int zIdx, int &iter)
virtual void | SetSpacing (float, float, float)
virtual void | SetSpacing (float[3])
virtual float * | GetSpacing ()
virtual void | GetSpacing (float &, float &, float &)
virtual void | GetSpacing (float[3])
virtual void | SetOrigin (float, float, float)
virtual void | SetOrigin (float[3])
virtual float * | GetOrigin ()
virtual void | GetOrigin (float &, float &, float &)
virtual void | GetOrigin (float[3])
virtual void | SetExtent (int, int, int, int, int, int)
virtual void | SetExtent (int[6])
virtual int * | GetExtent ()
virtual void | GetExtent (int &, int &, int &, int &, int &, int &)
virtual void | GetExtent (int[6])
virtual void | SetOldSpacing (float, float, float)
virtual void | SetOldSpacing (float[3])
virtual float * | GetOldSpacing ()
virtual void | GetOldSpacing (float &, float &, float &)
virtual void | GetOldSpacing (float[3])
virtual void | SetOldOrigin (float, float, float)
virtual void | SetOldOrigin (float[3])
virtual float * | GetOldOrigin ()
virtual void | GetOldOrigin (float &, float &, float &)
virtual void | GetOldOrigin (float[3])
## Static Public Methods
vtkImageStencilData * | New ()
int | IsTypeOf (const char *type)
vtkImageStencilData * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImageStencilData ()
| ~vtkImageStencilData ()
int | SpacingOrOriginHasChanged ()
## Protected Attributes
float | OldSpacing [3]
float | OldOrigin [3]
float | Spacing [3]
float | Origin [3]
int | NumberOfExtentEntries
int * | ExtentListLengths
int ** | ExtentLists

## Member Typedef Documentation

typedef vtkDataObject vtkImageStencilData::Superclass

| Reimplemented from vtkDataObject. Definition at line 50 of file vtkImageStencilData.h.

## Constructor & Destructor Documentation

vtkImageStencilData::vtkImageStencilData | ( |  | ) | `[protected]`

vtkImageStencilData::~vtkImageStencilData | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageStencilData* vtkImageStencilData::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkDataObject.

virtual const char* vtkImageStencilData::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataObject.

int vtkImageStencilData::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataObject.

virtual int vtkImageStencilData::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkDataObject.

vtkImageStencilData* vtkImageStencilData::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkDataObject.

void vtkImageStencilData::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkDataObject.

virtual vtkDataObject* vtkImageStencilData::MakeObject | ( |  | ) | `[virtual]`

| For legacy compatibility. Do not use. Reimplemented from vtkDataObject.

void vtkImageStencilData::Initialize | ( |  | ) | `[virtual]`

| Reimplemented from vtkDataObject.

void vtkImageStencilData::DeepCopy | ( | vtkDataObject * | o | ) | `[virtual]`

| Shallow and Deep copy. These copy the data, but not any of the pipeline connections. Reimplemented from vtkDataObject.

void vtkImageStencilData::ShallowCopy | ( | vtkDataObject * | f | ) | `[virtual]`

| Shallow and Deep copy. These copy the data, but not any of the pipeline connections. Reimplemented from vtkDataObject.

void vtkImageStencilData::InternalImageStencilDataCopy | ( | vtkImageStencilData * | s | ) |

int vtkImageStencilData::GetDataObjectType | ( |  | ) | `[inline, virtual]`

| Get the data type as an integer (this will return VTK_DATA_OBJECT for now, maybe a proper type constant will be reserved later). Reimplemented from vtkDataObject. Definition at line 66 of file vtkImageStencilData.h. References VTK_DATA_OBJECT.

int vtkImageStencilData::GetExtentType | ( |  | ) | `[inline, virtual]`

| The extent type is 3D, just like vtkImageData. Reimplemented from vtkDataObject. Definition at line 69 of file vtkImageStencilData.h. References VTK_3D_EXTENT.

int vtkImageStencilData::GetNextExtent | ( | int & | r1,
|  | int & | r2,
|  | int | xMin,
|  | int | xMax,
|  | int | yIdx,
|  | int | zIdx,
|  | int & | iter
| ) |

| Given the total output x extent [xMin,xMax] and the current y, z indices, return each sub-extent [r1,r2] that lies within within the unclipped region in sequence. A value of '0' is returned if no more sub-extents are available. The variable 'iter' must be initialized to zero before the first call, unless you want the complementary sub-extents in which case you must initialize 'iter' to -1. The variable 'iter' is used internally to keep track of which sub-extent should be returned next.

void vtkImageStencilData::InsertNextExtent | ( | int | r1,
|  | int | r2,
|  | int | yIdx,
|  | int | zIdx
| ) |

| This method is used by vtkImageStencilDataSource to add an x sub extent [r1,r2] for the x row (yIdx,zIdx). The specified sub extent must not intersect any other sub extents along the same x row. As well, r1 and r2 must both be within the total x extent [Extent[0],Extent[1]].

virtual void vtkImageStencilData::SetSpacing | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the desired spacing for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::SetSpacing | ( | float | [3] | ) | `[virtual]`

| Set the desired spacing for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual float* vtkImageStencilData::GetSpacing | ( |  | ) | `[virtual]`

| Set the desired spacing for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::GetSpacing | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set the desired spacing for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::GetSpacing | ( | float | [3] | ) | `[virtual]`

| Set the desired spacing for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::SetOrigin | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Set the desired origin for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::SetOrigin | ( | float | [3] | ) | `[virtual]`

| Set the desired origin for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual float* vtkImageStencilData::GetOrigin | ( |  | ) | `[virtual]`

| Set the desired origin for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::GetOrigin | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Set the desired origin for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::GetOrigin | ( | float | [3] | ) | `[virtual]`

| Set the desired origin for the stencil. This must be called before the stencil is Updated, ideally in the ExecuteInformation method of the imaging filter that is using the stencil.

virtual void vtkImageStencilData::SetExtent | ( | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) | `[virtual]`

| Set the extent of the data. This is should be called only by vtkImageStencilSource, as it is part of the basic pipeline functionality.

virtual void vtkImageStencilData::SetExtent | ( | int | [6] | ) | `[virtual]`

| Set the extent of the data. This is should be called only by vtkImageStencilSource, as it is part of the basic pipeline functionality.

virtual int* vtkImageStencilData::GetExtent | ( |  | ) | `[virtual]`

| Set the extent of the data. This is should be called only by vtkImageStencilSource, as it is part of the basic pipeline functionality.

virtual void vtkImageStencilData::GetExtent | ( | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & | ,
|  | int & |
| ) | `[virtual]`

| Set the extent of the data. This is should be called only by vtkImageStencilSource, as it is part of the basic pipeline functionality.

virtual void vtkImageStencilData::GetExtent | ( | int | [6] | ) | `[virtual]`

| Set the extent of the data. This is should be called only by vtkImageStencilSource, as it is part of the basic pipeline functionality.

virtual void vtkImageStencilData::SetOldSpacing | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Save the previous data spacing. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::SetOldSpacing | ( | float | [3] | ) | `[virtual]`

| Save the previous data spacing. This should be called only by vtkImageStencilSource.

virtual float* vtkImageStencilData::GetOldSpacing | ( |  | ) | `[virtual]`

| Save the previous data spacing. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::GetOldSpacing | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Save the previous data spacing. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::GetOldSpacing | ( | float | [3] | ) | `[virtual]`

| Save the previous data spacing. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::SetOldOrigin | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

| Save the previous data origin. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::SetOldOrigin | ( | float | [3] | ) | `[virtual]`

| Save the previous data origin. This should be called only by vtkImageStencilSource.

virtual float* vtkImageStencilData::GetOldOrigin | ( |  | ) | `[virtual]`

| Save the previous data origin. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::GetOldOrigin | ( | float & | ,
|  | float & | ,
|  | float & |
| ) | `[virtual]`

| Save the previous data origin. This should be called only by vtkImageStencilSource.

virtual void vtkImageStencilData::GetOldOrigin | ( | float | [3] | ) | `[virtual]`

| Save the previous data origin. This should be called only by vtkImageStencilSource.

void vtkImageStencilData::AllocateExtents | ( |  | ) |

| Allocate space for the sub-extents. This is called by vtkImageStencilSource.

void vtkImageStencilData::UpdateData | ( |  | ) | `[virtual]`

| WARNING: INTERNAL METHOD - NOT FOR GENERAL USE. THIS METHOD IS PART OF THE PIPELINE UPDATE FUNCTIONALITY. Propagate the update back up the pipeline, and perform the actual work of updating on the way down. When the propagate arrives at a port, block and wait for the asynchronous update to finish on the other side. This propagation may early terminate based on the PipelineMTime. Reimplemented from vtkDataObject.

void vtkImageStencilData::PropagateUpdateExtent | ( |  | ) | `[virtual]`

| WARNING: INTERNAL METHOD - NOT FOR GENERAL USE. THIS METHOD IS PART OF THE PIPELINE UPDATE FUNCTIONALITY. The update extent for this object is propagated up the pipeline. This propagation may early terminate based on the PipelineMTime. Reimplemented from vtkDataObject.

void vtkImageStencilData::TriggerAsynchronousUpdate | ( |  | ) | `[virtual]`

| WARNING: INTERNAL METHOD - NOT FOR GENERAL USE. THIS METHOD IS PART OF THE PIPELINE UPDATE FUNCTIONALITY. Propagate back up the pipeline for ports and trigger the update on the other side of the port to allow for asynchronous parallel processing in the pipeline. This propagation may early terminate based on the PipelineMTime. Reimplemented from vtkDataObject.

int vtkImageStencilData::SpacingOrOriginHasChanged | ( |  | ) | `[protected]`

| Check to see of the Spacing and Origin are different from the OldSpacing and OldOrigin.

## Member Data Documentation

float vtkImageStencilData::OldSpacing[3]`[protected]`

| Previous Spacing and Origin values, so that it is possible to know when an update is required because they have changed. Definition at line 165 of file vtkImageStencilData.h.

float vtkImageStencilData::OldOrigin[3]`[protected]`

| Previous Spacing and Origin values, so that it is possible to know when an update is required because they have changed. Definition at line 166 of file vtkImageStencilData.h.

float vtkImageStencilData::Spacing[3]`[protected]`

| The Spacing and Origin of the data. Definition at line 171 of file vtkImageStencilData.h.

float vtkImageStencilData::Origin[3]`[protected]`

| The Spacing and Origin of the data. Definition at line 172 of file vtkImageStencilData.h.

int vtkImageStencilData::NumberOfExtentEntries`[protected]`

| The actual 'data' is stored here. Definition at line 177 of file vtkImageStencilData.h.

int* vtkImageStencilData::ExtentListLengths`[protected]`

| The actual 'data' is stored here. Definition at line 178 of file vtkImageStencilData.h.

int** vtkImageStencilData::ExtentLists`[protected]`

| The actual 'data' is stored here. Definition at line 179 of file vtkImageStencilData.h.

The documentation for this class was generated from the following file:

- Imaging/vtkImageStencilData.h